'use strict';

var _defineProperty = require('@babel/runtime/helpers/defineProperty');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty__default["default"](target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/**
 * @param {MinterApiInstance} apiInstance
 * @param {import('axios').AxiosRequestConfig} [factoryAxiosOptions]
 * @return {function(AxiosRequestConfig=): Promise<CommissionPriceData>}
 */
function GetCommissionPrice(apiInstance, factoryAxiosOptions) {
  /**
   * Get nonce for new transaction: last transaction number + 1
   * @param {import('axios').AxiosRequestConfig} [axiosOptions]
   * @return {Promise<CommissionPriceData>}
   */
  return function getCommissionPrice(axiosOptions) {
    return apiInstance.get('price_commissions', _objectSpread(_objectSpread({}, factoryAxiosOptions), axiosOptions)).then(function (response) {
      return response.data;
    });
  };
}

module.exports = GetCommissionPrice;
