'use strict';

var _defineProperty = require('@babel/runtime/helpers/defineProperty');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var _defineProperty__default = /*#__PURE__*/_interopDefaultLegacy(_defineProperty);

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty__default["default"](target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

/**
 * @param {MinterApiInstance} apiInstance
 * @param {import('axios').AxiosRequestConfig} [factoryAxiosOptions]
 * @return {function(coin0: number|string, coin1: number|string, axiosOptions: AxiosRequestConfig=): Promise<PoolInfo>}
 */
function GetPoolInfo(apiInstance, factoryAxiosOptions) {
  return getPoolInfo;
  /**
   * Get nonce for new transaction: last transaction number + 1
   * @param {number|string} coin0 - first coin id
   * @param {number|string} coin1 - second coin id
   * @param {import('axios').AxiosRequestConfig} [axiosOptions]
   * @return {Promise<PoolInfo>}
   */

  function getPoolInfo(coin0, coin1, axiosOptions) {
    return apiInstance.get("swap_pool/".concat(coin0, "/").concat(coin1), _objectSpread(_objectSpread({}, factoryAxiosOptions), axiosOptions)).then(function (response) {
      return response.data;
    });
  }
}
/**
 * @typedef {object} PoolInfo
 * @property {string|number} amount0
 * @property {string|number} amount1
 * @property {string|number} liquidity
 */

module.exports = GetPoolInfo;
